## vnlog 1.12

=== Makefile ===
PROJECT_NAME := vnlog

ABI_VERSION  := 0
TAIL_VERSION := 1

LIB_SOURCES := *.c*
BIN_SOURCES := test/test1.c

TOOLS :=					\
  vnl-filter					\
  vnl-gen-header				\
  vnl-tail					\
  vnl-make-matrix				\
  vnl-align					\
  vnl-join					\
  vnl-sort


# I construct the README.org from the template. The only thing I do is to insert
# the manpages
define MAKE_README =
BEGIN									\
{									\
  for $$a (@ARGV)							\
  {									\
    $$c{$$a} = `pod2text $$a | mawk "/REPOSITORY/{exit} {print}"`;	\
  }									\
}									\
									\
while(<STDIN>)								\
{									\
  print s/xxx-manpage-(.*?)-xxx/$$c{$$1}/gr;				\
}
endef

README.org: README.template.org vnl-filter vnl-align vnl-sort vnl-join vnl-tail
	< $(filter README%,$^) perl -e '$(MAKE_README)' $(filter-out README%,$^) > $@
all: README.org



b64_cencode.o: CFLAGS += -Wno-implicit-fallthrough

# Make can't deal with ':' in filenames, so I hack it
coloncolon := __colon____colon__
doc: $(addprefix man1/,$(addsuffix .1,$(TOOLS)))  $(patsubst lib/Vnlog/%.pm,man3/Vnlog$(coloncolon)%.3pm,$(wildcard lib/Vnlog/*.pm))
.PHONY: doc

%/:
	mkdir -p $@

man1/%.1: % | man1/
	pod2man -r '' --section 1 --center "vnlog" $< $@
man3/Vnlog$(coloncolon)%.3pm: lib/Vnlog/%.pm | man3/
	pod2man -r '' --section 3pm --center "vnlog" $< $@
EXTRA_CLEAN += man1 man3

CFLAGS := -I. -std=gnu99 -Wno-missing-field-initializers

test/test1: test/test2.o
test/test1.o: test/vnlog_fields_generated1.h
test/test2.o: test/vnlog_fields_generated2.h
test/vnlog_fields_generated%.h: test/vnlog%.defs vnl-gen-header
	./vnl-gen-header < $< | perl -pe 's{vnlog/vnlog.h}{vnlog.h}' > $@
EXTRA_CLEAN += test/vnlog_fields_generated*.h test/*.got

# Set up the test suite to be runnable in parallel
test check:					\
   test/test_vnl-filter.pl.RUN			\
   test/test_vnl-sort.pl.RUN			\
   test/test_vnl-join.pl.RUN			\
   test/test_c_api.sh.RUN			\
   test/test_perl_parser.pl.RUN			\
   test/test_python2_parser.sh.RUN              \
   test/test_python3_parser.sh.RUN
	@echo "All tests in the test suite passed!"
.PHONY: test check
%.RUN: %
	$<
test/test_c_api.sh.RUN: test/test1
EXTRA_CLEAN += test/testdata_*


DIST_INCLUDE      := vnlog.h
DIST_BIN          := $(TOOLS)
DIST_PERL_MODULES := lib/Vnlog
DIST_PY2_MODULES  := lib/vnlog.py
DIST_PY3_MODULES  := lib/vnlog.py

install: doc
DIST_MAN     := man1/ man3/







# This is the chunks of the Makefile.common from mrbuild that we need. I don't
# want to introduce a dependency in this public project, so I simply copy the
# build boilerplate. It's unlikely to change.



# The default VERSION string that appears as a #define to each source file, and
# to any generated documentation (gengetopt and so on). The user can set this to
# whatever they like
VERSION ?= $(ABI_VERSION).$(TAIL_VERSION)

# Default compilers. By default, we use g++ as a linker
CC        ?= gcc
CC_LINKER ?= $(CC)

# used to make gcc output header dependency information. All source
# files generated .d dependency definitions that are included at the
# bottom of this file
CCXXFLAGS += -MMD -MP

# always building with debug information. This is stripped into the
# -dbg/-debuginfo packages by debhelper/rpm later
CCXXFLAGS += -g

# I want the frame pointer. Makes walking the stack WAY easier
CCXXFLAGS += -fno-omit-frame-pointer

# all warnings by default
CCXXFLAGS += -Wall -Wextra


# I look through my LIB_SOURCES and BIN_SOURCES. Anything that isn't a wildcard
# (has * or ?) should exist. If it doesn't, the user messed up and I flag it
get_no_wildcards          = $(foreach v,$1,$(if $(findstring ?,$v)$(findstring *,$v),,$v))
complain_if_nonempty      = $(if $(strip $1),$(error $2: $1))
complain_unless_all_exist = $(call complain_if_nonempty,$(call get_no_wildcards,$(filter-out $(wildcard $1),$1)),File not found: )
$(call complain_unless_all_exist,$(LIB_SOURCES) $(BIN_SOURCES))


LIB_SOURCES := $(wildcard $(LIB_SOURCES))
BIN_SOURCES := $(wildcard $(BIN_SOURCES))

LIB_OBJECTS := $(addsuffix .o,$(basename $(LIB_SOURCES)))
BIN_OBJECTS := $(addsuffix .o,$(basename $(BIN_SOURCES)))

SOURCE_DIRS := $(sort ./ $(dir $(LIB_SOURCES) $(BIN_SOURCES)))

# if the PROJECT_NAME is libxxx then LIB_NAME is libxxx
# if the PROJECT_NAME is xxx    then LIB_NAME is libxxx
LIB_NAME           := $(or $(filter lib%,$(PROJECT_NAME)),lib$(PROJECT_NAME))
LIB_TARGET_SO_BARE := $(LIB_NAME).so
LIB_TARGET_SO_ABI  := $(LIB_TARGET_SO_BARE).$(ABI_VERSION)
LIB_TARGET_SO_FULL := $(LIB_TARGET_SO_ABI).$(TAIL_VERSION)
LIB_TARGET_SO_ALL  := $(LIB_TARGET_SO_BARE) $(LIB_TARGET_SO_ABI) $(LIB_TARGET_SO_FULL)

BIN_TARGETS := $(basename $(BIN_SOURCES))


# all objects built for inclusion in shared libraries get -fPIC. We don't build
# static libraries, so this is 100% correct
$(LIB_OBJECTS): CCXXFLAGS += -fPIC

CCXXFLAGS += -DVERSION='"$(VERSION)"'




# These are here to process the options separately for each file being built.
# This allows per-target options to be set
#
# if no explicit optimization flags are given, optimize
define massageopts
$1 $(if $(filter -O%,$1),,-O3)
endef

# If no C++ standard requested, I default to c++0x
define massageopts_cxx
$(call massageopts,$1 $(if $(filter -std=%,$1),,-std=c++0x))
endef

define massageopts_c
$(call massageopts,$1)
endef



# define the compile rules. I need to redefine the rules here because my
# C..FLAGS variables are simple (immediately evaluated), but the user
# could have specified per-target flags that ALWAYS evaluate deferred-ly
c_build_rule  = $(strip $(CC)   $(call massageopts_c,  $(CFLAGS)   $(CCXXFLAGS) $(CPPFLAGS))) -c -o $@ $<


%.o:%.c
	$(c_build_rule)


# by default I build shared libraries only. We known how to build static
# libraries too, but I don't do it unless asked
all: $(if $(strip $(LIB_SOURCES)),$(LIB_TARGET_SO_ALL)) $(if $(strip $(BIN_SOURCES)),$(BIN_TARGETS))
.PHONY: all
.DEFAULT_GOAL := all

$(LIB_TARGET_SO_FULL): LDFLAGS += -shared -Wl,--default-symver -fPIC -Wl,-soname,$(notdir $(LIB_TARGET_SO_BARE)).$(ABI_VERSION)

$(LIB_TARGET_SO_BARE) $(LIB_TARGET_SO_ABI): $(LIB_TARGET_SO_FULL)
	ln -fs $(notdir $(LIB_TARGET_SO_FULL)) $@

# Here instead of specifying $^, I do just the %.o parts and then the
# others. This is required to make the linker happy to see the dependent
# objects first and the dependency objects last. Same as for BIN_TARGETS
$(LIB_TARGET_SO_FULL): $(LIB_OBJECTS)
	$(CC_LINKER) $(LDFLAGS) $(filter %.o, $^) $(filter-out %.o, $^) $(LDLIBS) -o $@

# I make sure to give the .o to the linker before the .so and everything else.
# The .o may depend on the other stuff. The binaries get an rpath (removed at
# install time)
$(BIN_TARGETS): %: %.o
	$(CC_LINKER) -Wl,-rpath=$(abspath .) $(LDFLAGS) $(filter %.o, $^) $(filter-out %.o, $^) $(LDLIBS) -o $@

# The binaries link with the DSO, if there is one. I need the libxxx.so to build
# the binary, and I need the libxxx.so.abi to run it.
$(BIN_TARGETS): $(if $(strip $(LIB_SOURCES)),$(LIB_TARGET_SO_BARE) $(LIB_TARGET_SO_ABI))




clean:
	rm -rf $(foreach d,$(SOURCE_DIRS),$(addprefix $d,*.a *.o *.so *.so.* *.d moc_* ui_*.h*)) $(BIN_TARGETS) $(foreach s,.c .h,$(addsuffix $s,$(basename $(shell find . -name '*.ggo')))) $(EXTRA_CLEAN)
distclean: clean

.PHONY: distclean clean



########################### installation business
# The distro will 'DESTDIR=debian/tmp make install'. I then set PREFIX=/usr to
# install everything into debian/tmp/usr
#
# A user might do 'PREFIX=/usr/local make install' to write to /usr/local/lib,
# /usr/local/bin, ...

ifneq (,$(filter install,$(MAKECMDGOALS)))
  ifeq  ($(strip $(DESTDIR)$(PREFIX)),)
    $(error 'make install' MUST be called with EITHER DESTDIR or PREFIX defined. \
"DESTDIR=xxx make install" is for package building; \
"PREFIX=/usr/local make install" is for local installs; \
What are you trying to do?)
  endif

  ifneq ($(and $(DESTDIR),$(PREFIX)),)
    $(error 'make install' MUST be called with EITHER DESTDIR or PREFIX defined. \
"DESTDIR=xxx make install" is for package building; \
"PREFIX=/usr/local make install" is for local installs; \
What are you trying to do?)
  endif

  ifneq ($(DESTDIR),)
PREFIX := /usr
  endif

  ifneq ($(PREFIX),)
# DESTDIR should be empty, and is already empty
  endif
endif


# I process the simple wildcard exceptions on DIST_BIN and DIST_INCLUDE in a
# deferred fashion. The reason is that I wand $(wildcard) to run at install
# time, i.e. after stuff is built, and the files $(wildcard) is looking at
# already exist
DIST_BIN_ORIG     := $(DIST_BIN)
DIST_INCLUDE_ORIG := $(DIST_INCLUDE)

DIST_BIN     = $(filter-out $(wildcard $(DIST_BIN_EXCEPT)),		\
                  $(wildcard $(or $(DIST_BIN_ORIG),    $(BIN_TARGETS))))
DIST_INCLUDE = $(filter-out $(wildcard $(DIST_INCLUDE_EXCEPT)),		\
		  $(wildcard $(DIST_INCLUDE_ORIG)))

ifneq (,$(shell grep -qi debian /etc/os-release 2>/dev/null && echo yep))
  # we're a debian box, use the multiarch dir
  DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)
  USRLIB             := $(PREFIX)/lib/$(DEB_HOST_MULTIARCH)
else
  # we're something else. If /usr/lib64 exists, use that. Otherwise /usr/lib
  USRLIB := $(if $(wildcard $(PREFIX)/lib64),$(PREFIX)/lib64,$(PREFIX)/lib)
endif

# Generates the install rules. Arguments:
#   1. variable containing the being installed
#   2. target path they're being installed to
#   3. post-install commands
define install_rule
$(if $(strip $($1)),
	mkdir -p $2 &&									\
	cp -r $($1) $2 &&								\
	$(if $($(1)_EXCEPT_FINDSPEC),find $2 $($(1)_EXCEPT_FINDSPEC) -delete &&)	\
	$(or $3,true) )
endef

ifneq ($(strip $(LIB_SOURCES)),)
install: $(LIB_TARGET_SO_ALL)
endif

install: $(BIN_TARGETS) $(DIST_DOC) $(DIST_MAN) $(DIST_DATA)

# using 'cp -P' instead of 'install' because the latter follows links unconditionally
ifneq ($(strip $(LIB_SOURCES)),)
	mkdir -p $(DESTDIR)/$(USRLIB)
	cp -P $(LIB_TARGET_SO_FULL)  $(DESTDIR)/$(USRLIB)
	ln -fs $(notdir $(LIB_TARGET_SO_FULL)) $(DESTDIR)/$(USRLIB)/$(notdir $(LIB_TARGET_SO_ABI))
	ln -fs $(notdir $(LIB_TARGET_SO_FULL)) $(DESTDIR)/$(USRLIB)/$(notdir $(LIB_TARGET_SO_BARE))
endif
	$(call install_rule,DIST_BIN,         $(DESTDIR)$(PREFIX)/bin,)
	$(call install_rule,DIST_INCLUDE,     $(DESTDIR)$(PREFIX)/include/$(PROJECT_NAME),)
	$(call install_rule,DIST_DOC,         $(DESTDIR)$(PREFIX)/share/doc/$(PROJECT_NAME),)
	$(call install_rule,DIST_MAN,         $(DESTDIR)$(PREFIX)/share/man,)
	$(call install_rule,DIST_DATA,        $(DESTDIR)$(PREFIX)/share/$(PROJECT_NAME),)
	$(call install_rule,DIST_PERL_MODULES,$(DESTDIR)$(PREFIX)/share/perl5,)
	$(call install_rule,DIST_PY2_MODULES, $(DESTDIR)$(PREFIX)/lib/python2.7/dist-packages,)
	$(call install_rule,DIST_PY3_MODULES, $(DESTDIR)$(PREFIX)/lib/python3/dist-packages,)

        # In filenames I rename __colon__ -> :
        # This is required because Make can't deal with : in rules
	for fil in `find $(DESTDIR) -name '*__colon__*'`; do mv $$fil `echo $$fil | sed s/__colon__/:/g`; done

        # Remove rpaths from everything. /usr/bin is allowed to fail because
        # some of those executables aren't ELFs. On the other hand, any .so we
        # find IS en ELF. Those could live in a number of places, since they
        # could be extension modules for the various languages, and I thus look
        # for those EVERYWHERE
ifneq ($(strip $(DIST_BIN)),)
	$(if $(wildcard $(DESTDIR)$(PREFIX)/bin/*),chrpath -d $(DESTDIR)$(PREFIX)/bin/* 2>/dev/null || true)
endif
	find $(DESTDIR) -name '*.so' | xargs chrpath -d

        # Any perl programs need their binary path stuff stripped out. This
        # exists to let these run in-tree, but needs to be removed at
        # install-time (similar to an RPATH)
ifneq ($(strip $(DIST_BIN)),)
	for fil in `find $(DESTDIR)$(PREFIX)/bin -type f`; do head -n1 $$fil | grep -q '^#!.*/perl$$' && perl -n -i -e 'print unless /^\s* use \s+ lib \b/x' $$fil; done
endif
	find $(DESTDIR)$(PREFIX)/share/perl5 -type f | xargs perl -n -i -e 'print unless /^\s* use \s+ lib \b/x'

ifneq ($(strip $(DIST_BIN)),)

=== debian/changelog ===
vnlog (1.12-1) unstable; urgency=medium

  * New upstream release: fixed parallel testing
    - Bug fix: "FTBFS: test failures", thanks to
      Niko Tyni (Closes: #901540).

 -- Dima Kogan <dkogan@debian.org>  Sun, 17 Jun 2018 21:01:40 -0700

vnlog (1.11-1) unstable; urgency=medium

  * New upstream release:
    - N-way vnl-join: fixed deadlock with large files

 -- Dima Kogan <dkogan@debian.org>  Fri, 15 Jun 2018 19:35:22 -0700

vnlog (1.10-1) unstable; urgency=medium

  * New upstream release; vnl-join updates:
    - N-way vnl-join now invoke the sub-joins in parallel
    - Updated tab completion with new vnl-join arguments
    - 'make clean' leaves the README.org alone

 -- Dima Kogan <dkogan@debian.org>  Fri, 15 Jun 2018 15:03:22 -0700

vnlog (1.9-1) unstable; urgency=medium

  * New upstream release; vnl-join updates:
    - N-way joins are supported rather than just 2-way
    - -a- available as a shorthand for -a1 -a2 -a3 -a4 ...
    - -v- available as a shorthand for -v1 -v2 -v3 -v4 ...
    - --vnl-autoprefix/--vnl-autosuffix available to infer
      the prefix/suffix from the filenames

 -- Dima Kogan <dkogan@debian.org>  Tue, 12 Jun 2018 23:22:10 -0700

vnlog (1.7-1) unstable; urgency=medium

  * New upstream release:
    - vnl-filter: added exclusion columns: vnl-filter -p !xxx
    - vnl-filter handles duplicate columns robustly
    - 'vnl-filter -p x*' no longer matches all the columns
    - README.org now contains all the manpages

 -- Dima Kogan <dkogan@debian.org>  Thu, 26 Apr 2018 20:34:21 -0700

vnlog (1.6-1) unstable; urgency=medium

  * New upstream release. C library works on armhf, armel

 -- Dima Kogan <dkogan@debian.org>  Sun, 01 Apr 2018 22:14:38 -0700

vnlog (1.5-1) unstable; urgency=medium

  * Initial release (Closes: #891595)

 -- Dima Kogan <dkogan@debian.org>  Sat, 31 Mar 2018 15:06:12 -0700

=== debian/control ===
Source: vnlog
Priority: optional
Section: devel
Build-Depends: debhelper (>= 11),
 dh-python,
 python3:any,
 python-all,
 libipc-run-perl,
 libtext-diff-perl,
 libstring-shellquote-perl,
 liblist-moreutils-perl,
 python-numpy,
 python3-numpy,
 perl,
 mawk,
 chrpath
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.1.3
Homepage: https://github.com/dkogan/vnlog/
Vcs-Git: https://salsa.debian.org/science-team/vnlog.git
Vcs-Browser: https://salsa.debian.org/science-team/vnlog

Package: libvnlog0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog (pronounced "vanillog") is a trivially-simple log format consisting of an
 ASCII table with comments and labelled fields. This package provides a C
 library that simplifies generating such logs.

Package: libvnlog-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libvnlog0 (= ${binary:Version}), ${perl:Depends},
 libstring-shellquote-perl
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog (pronounced "vanillog") is a trivially-simple log format consisting of an
 ASCII table with comments and labelled fields. This package provides a C
 library that simplifies generating such logs. Dev files.

Package: vnlog
Section: libdevel
Architecture: all
Depends: ${misc:Depends},
 libvnlog-perl (= ${binary:Version}), ${perl:Depends},
 mawk,
 libtext-table-perl,
 liblist-moreutils-perl
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog (pronounced "vanillog") is a trivially-simple log format consisting of an
 ASCII table with comments and labelled fields. This package provides tools to
 process and manipulate such logs. The tools are:
 .
 vnl-filter selects a subset of the rows/columns in a vnlog and/or to
 manipulates the contents. This is effectively an awk wrapper.
 .
 vnl-sort, vnl-join and vnl-tail are wrappers around the corresponding GNU
 Coreutils tools
 .
 vnl-align aligns vnlog columns for easy interpretation by humans
 .
 vnl-make-matrix converts a one-point-per-line vnlog to a matrix of data

Package: libvnlog-perl
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog (pronounced "vanillog") is a trivially-simple log format consisting of an
 ASCII table with comments and labelled fields. This package provides a simple
 Perl library to parse such logs.

Package: python-vnlog
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}, python-numpy
Provides: ${python:Provides}
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog (pronounced "vanillog") is a trivially-simple log format consisting of an
 ASCII table with comments and labelled fields. This package provides a simple
 Python2 library to parse such logs.

Package: python3-vnlog
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}, python3-numpy
Provides: ${python3:Provides}
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog (pronounced "vanillog") is a trivially-simple log format consisting of an
 ASCII table with comments and labelled fields. This package provides a simple
 Python3 library to parse such logs.

## vnlog 1.16

=== Makefile ===
--- 
+++ 
@@ -9,15 +9,23 @@
 TOOLS :=					\
   vnl-filter					\
   vnl-gen-header				\
-  vnl-tail					\
   vnl-make-matrix				\
   vnl-align					\
+  vnl-sort					\
   vnl-join					\
-  vnl-sort
+  vnl-tail					\
+  vnl-ts
 
 
 # I construct the README.org from the template. The only thing I do is to insert
-# the manpages
+# the manpages. Note that this is more complicated than it looks:
+#
+# 1. The tools are written in perl and contain POD documentation
+# 2. This documentation is stripped out here with pod2text, and included in the
+#    README. This README is an org-mode file, and the README.template.org
+#    container included the manpage text inside a #+BEGIN_EXAMPLE/#+END_EXAMPLE.
+#    So the manpages are treated as a verbatim, unformatted text blob
+# 3. Further down, the same POD is converted to a manpage via pod2man
 define MAKE_README =
 BEGIN									\
 {									\
@@ -33,7 +41,7 @@
 }
 endef
 
-README.org: README.template.org vnl-filter vnl-align vnl-sort vnl-join vnl-tail
+README.org: README.template.org vnl-filter vnl-align vnl-sort vnl-join vnl-tail vnl-ts
 	< $(filter README%,$^) perl -e '$(MAKE_README)' $(filter-out README%,$^) > $@
 all: README.org
 
@@ -331,12 +339,3 @@
 endif
 	find $(DESTDIR) -name '*.so' | xargs chrpath -d
 
-        # Any perl programs need their binary path stuff stripped out. This
-        # exists to let these run in-tree, but needs to be removed at
-        # install-time (similar to an RPATH)
-ifneq ($(strip $(DIST_BIN)),)
-	for fil in `find $(DESTDIR)$(PREFIX)/bin -type f`; do head -n1 $$fil | grep -q '^#!.*/perl$$' && perl -n -i -e 'print unless /^\s* use \s+ lib \b/x' $$fil; done
-endif
-	find $(DESTDIR)$(PREFIX)/share/perl5 -type f | xargs perl -n -i -e 'print unless /^\s* use \s+ lib \b/x'
-
-ifneq ($(strip $(DIST_BIN)),)

=== debian/changelog ===
vnlog (1.16-1) unstable; urgency=medium

  * New upstream release:
    - 'vnl-join --vnl-sort' runs a STABLE pre-sort

 -- Dima Kogan <dkogan@debian.org>  Mon, 21 Jan 2019 17:31:44 -0800

vnlog (1.15-1) unstable; urgency=medium

  * New upstream release:
    - Vnlog::Parser perl library handles whitespace properly
    - "vnl-filter --stream" is now a synonym for
      "vnl-filter --unbuffered"
    - added new tool: vnl-ts

 -- Dima Kogan <dkogan@debian.org>  Sun, 06 Jan 2019 21:29:58 -0800

vnlog (1.13-1) unstable; urgency=medium

  * New upstream release:
    - vnl-join doesn't get confused by trailing whitespace
    - vnl-filter new special-operations: sum(), prev()

 -- Dima Kogan <dkogan@debian.org>  Sun, 02 Dec 2018 13:52:06 -0800

=== debian/control ===
--- 
+++ 
@@ -49,7 +49,8 @@
  libvnlog-perl (= ${binary:Version}), ${perl:Depends},
  mawk,
  libtext-table-perl,
- liblist-moreutils-perl
+ liblist-moreutils-perl,
+ moreutils
 Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
  Vnlog (pronounced "vanillog") is a trivially-simple log format consisting of an
  ASCII table with comments and labelled fields. This package provides tools to
@@ -58,14 +59,15 @@
  vnl-filter selects a subset of the rows/columns in a vnlog and/or to
  manipulates the contents. This is effectively an awk wrapper.
  .
- vnl-sort, vnl-join and vnl-tail are wrappers around the corresponding GNU
- Coreutils tools
+ vnl-sort, vnl-join, vnl-tail and vnl-ts are wrappers around the corresponding
+ commandline tools
  .
  vnl-align aligns vnlog columns for easy interpretation by humans
  .
  vnl-make-matrix converts a one-point-per-line vnlog to a matrix of data
 
 Package: libvnlog-perl
+Section: perl
 Architecture: all
 Depends: ${misc:Depends}, ${perl:Depends}
 Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
@@ -74,6 +76,7 @@
  Perl library to parse such logs.
 
 Package: python-vnlog
+Section: python
 Architecture: all
 Depends: ${misc:Depends}, ${python:Depends}, python-numpy
 Provides: ${python:Provides}
@@ -83,6 +86,7 @@
  Python2 library to parse such logs.
 
 Package: python3-vnlog
+Section: python
 Architecture: all
 Depends: ${misc:Depends}, ${python3:Depends}, python3-numpy
 Provides: ${python3:Provides}

## vnlog 1.19

=== debian/changelog ===
vnlog (1.19-1) unstable; urgency=medium

  * New upstream release:
    - vnl-filter -p 'prev(x)' now outputs '-' for the first line
    - Looser handling of whitespace in vnl-filter, vnl-join, parsers, etc

 -- Dima Kogan <dkogan@debian.org>  Mon, 08 Jul 2019 23:29:55 -0700

vnlog (1.17-1) unstable; urgency=medium

  * New upstream release:
    - vnl-join --autoprefix handles numerical filenames better
    - vnl-filter supports grep-style -A/-B/-C options

 -- Dima Kogan <dkogan@debian.org>  Fri, 29 Mar 2019 18:31:35 -0700

## vnlog 1.26

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,8 @@
   vnl-sort					\
   vnl-join					\
   vnl-tail					\
-  vnl-ts
+  vnl-ts					\
+  vnl-uniq
 
 
 # I construct the README.org from the template. The only thing I do is to insert
@@ -41,7 +42,7 @@
 }
 endef
 
-README.org: README.template.org vnl-filter vnl-align vnl-sort vnl-join vnl-tail vnl-ts
+README.org: README.template.org vnl-filter vnl-align vnl-sort vnl-join vnl-tail vnl-ts vnl-uniq
 	< $(filter README%,$^) perl -e '$(MAKE_README)' $(filter-out README%,$^) > $@
 all: README.org
 
@@ -89,7 +90,7 @@
 EXTRA_CLEAN += test/testdata_*
 
 
-DIST_INCLUDE      := vnlog.h
+DIST_INCLUDE      := vnlog*.h
 DIST_BIN          := $(TOOLS)
 DIST_PERL_MODULES := lib/Vnlog
 DIST_PY2_MODULES  := lib/vnlog.py

=== debian/changelog ===
vnlog (1.26-1) unstable; urgency=medium

  * New upstream release
    - vnl-filter --stream --eval is allowed again: it's once again
      possible to produce unbuffered output with awk

 -- Dima Kogan <dkogan@debian.org>  Mon, 03 Feb 2020 22:18:21 -0800

vnlog (1.25-1) unstable; urgency=medium

  * New upstream release
    - vnl-filter: rel()/diff()/prev() work next to newlines
  * Added Suggests:datamash

 -- Dima Kogan <dkogan@debian.org>  Wed, 29 Jan 2020 15:56:52 -0800

vnlog (1.24-2) unstable; urgency=medium

  * Merged with Ondřej Nový's 1.21-2 release

 -- Dima Kogan <dkogan@debian.org>  Sat, 21 Dec 2019 13:42:36 -0800

vnlog (1.24-1) unstable; urgency=medium

  * New upstream release
    - vnl-join handles empty vnlog files properly
    - vnl-filter diff() returns - for the first record
    - added vnl-uniq

 -- Dima Kogan <dkogan@debian.org>  Sat, 21 Dec 2019 12:35:04 -0800

vnlog (1.21-2) unstable; urgency=medium

  * Team upload.
  * Drop Python 2 support (Closes: #938796).
  * d/copyright: Use https protocol in Format field.
  * Use debhelper-compat instead of debian/compat.
  * Enable autopkgtest-pkg-python testsuite.

 -- Ondřej Nový <onovy@debian.org>  Mon, 28 Oct 2019 13:08:35 +0100

vnlog (1.21-1) unstable; urgency=medium

  * vnlog Suggests: feedgnuplot, ministat
  * New upstream release
    - --has can take regular expressions
    - Columns with = in the name are now supported
    - Exported the base64 interface. It's now usable standalone

 -- Dima Kogan <dkogan@debian.org>  Sun, 25 Aug 2019 16:16:24 -0700

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: vnlog
 Priority: optional
 Section: devel
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 11),
  dh-python,
  python3:any,
- python-all,
  libipc-run-perl,
  libtext-diff-perl,
  libstring-shellquote-perl,
  liblist-moreutils-perl,
- python-numpy,
  python3-numpy,
  perl,
  mawk,
@@ -20,6 +18,7 @@
 Homepage: https://github.com/dkogan/vnlog/
 Vcs-Git: https://salsa.debian.org/science-team/vnlog.git
 Vcs-Browser: https://salsa.debian.org/science-team/vnlog
+Testsuite: autopkgtest-pkg-python
 
 Package: libvnlog0
 Section: libs
@@ -51,6 +50,7 @@
  libtext-table-perl,
  liblist-moreutils-perl,
  moreutils
+Suggests: feedgnuplot, ministat, datamash
 Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
  Vnlog (pronounced "vanillog") is a trivially-simple log format consisting of an
  ASCII table with comments and labelled fields. This package provides tools to
@@ -59,8 +59,8 @@
  vnl-filter selects a subset of the rows/columns in a vnlog and/or to
  manipulates the contents. This is effectively an awk wrapper.
  .
- vnl-sort, vnl-join, vnl-tail and vnl-ts are wrappers around the corresponding
- commandline tools
+ vnl-sort, vnl-uniq, vnl-join, vnl-tail and vnl-ts are wrappers around the
+ corresponding commandline tools
  .
  vnl-align aligns vnlog columns for easy interpretation by humans
  .
@@ -75,16 +75,6 @@
  ASCII table with comments and labelled fields. This package provides a simple
  Perl library to parse such logs.
 
-Package: python-vnlog
-Section: python
-Architecture: all
-Depends: ${misc:Depends}, ${python:Depends}, python-numpy
-Provides: ${python:Provides}
-Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
- Vnlog (pronounced "vanillog") is a trivially-simple log format consisting of an
- ASCII table with comments and labelled fields. This package provides a simple
- Python2 library to parse such logs.
-
 Package: python3-vnlog
 Section: python
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

%:
	dh $@ --with python3

override_dh_auto_build:
	make all doc

## vnlog 1.30

=== debian/changelog ===
vnlog (1.30-1) unstable; urgency=medium

  * New upstream release
    - vnl-align: empty lines are treated like comments, and are preserved
    - vnl-filter bug fix: --perl puts () around each "match" expression
  
 -- Dima Kogan <dkogan@debian.org>  Mon, 03 Aug 2020 02:15:55 -0700

vnlog (1.28-1) unstable; urgency=medium

  * New upstream release
    - vnl-filter produces - for any expression that evaluates to an empty
      string
    - vnlog_set_output_FILE() can take ctx==NULL for the global context
    - cmdline tools have --vnl-tool to specify the underlying tool

 -- Dima Kogan <dkogan@debian.org>  Wed, 03 Jun 2020 20:16:44 -0700

## vnlog 1.31

=== debian/changelog ===
vnlog (1.31-1) unstable; urgency=medium

  * New upstream release
    - vnl-filter: correct behavior with field names containing small
      integers

 -- Dima Kogan <dkogan@debian.org>  Wed, 09 Dec 2020 12:19:53 -0800

## vnlog 1.32

=== debian/changelog ===
vnlog (1.32-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * source only upload to enable migration (Closes: #1002877)

 -- Paul Gevers <elbrus@debian.org>  Thu, 30 Dec 2021 19:52:30 +0100

vnlog (1.32-1) unstable; urgency=medium

  * New upstream release
    - Python parser can handle trailing comments
    - Bug fix: symlinked binaries work (Thanks to Jim Radford for the
      report)
    - Python vnlog.slurp() always returns 2D arrays
    - added latestdefined() to vnl-filter

 -- Dima Kogan <dkogan@debian.org>  Fri, 29 Oct 2021 14:12:09 -0700

## vnlog 1.33

=== debian/changelog ===
vnlog (1.33-1) unstable; urgency=medium

  * New upstream release
    - vnl-filter: added --begin, --end, --sub-abs, -l

 -- Dima Kogan <dkogan@debian.org>  Tue, 28 Jun 2022 14:45:03 -0700

=== debian/control ===
Source: vnlog
Priority: optional
Section: devel
Build-Depends: debhelper-compat (= 11),
 dh-python,
 python3:any,
 libipc-run-perl,
 libtext-diff-perl,
 libstring-shellquote-perl,
 liblist-moreutils-perl,
 python3-numpy,
 perl,
 mawk,
 chrpath
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.1.3
Homepage: https://github.com/dkogan/vnlog/
Vcs-Git: https://salsa.debian.org/science-team/vnlog.git
Vcs-Browser: https://salsa.debian.org/science-team/vnlog
Testsuite: autopkgtest-pkg-python

Package: libvnlog0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog ("vanillog") is a trivially-simple log format consisting of an ASCII
 table with comments and labelled fields. This package provides a C library that
 simplifies generating such logs.

Package: libvnlog-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libvnlog0 (= ${binary:Version}), ${perl:Depends},
 libstring-shellquote-perl
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog ("vanillog") is a trivially-simple log format consisting of an ASCII
 table with comments and labelled fields. This package provides a C library that
 simplifies generating such logs. Dev files.

Package: vnlog
Section: libdevel
Architecture: all
Depends: ${misc:Depends},
 libvnlog-perl (= ${binary:Version}), ${perl:Depends},
 mawk,
 libtext-table-perl,
 liblist-moreutils-perl,
 moreutils
Suggests: feedgnuplot, ministat, datamash
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog ("vanillog") is a trivially-simple log format consisting of an ASCII
 table with comments and labelled fields. This package provides tools to process
 and manipulate such logs. The tools are:
 .
 vnl-filter selects a subset of the rows/columns in a vnlog and/or to
 manipulates the contents. This is effectively an awk wrapper.
 .
 vnl-sort, vnl-uniq, vnl-join, vnl-tail and vnl-ts are wrappers around the
 corresponding commandline tools
 .
 vnl-align aligns vnlog columns for easy interpretation by humans
 .
 vnl-make-matrix converts a one-point-per-line vnlog to a matrix of data

Package: libvnlog-perl
Section: perl
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog ("vanillog") is a trivially-simple log format consisting of an ASCII
 table with comments and labelled fields. This package provides a simple Perl
 library to parse such logs.

Package: python3-vnlog
Section: python
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}, python3-numpy
Provides: ${python3:Provides}
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog ("vanillog") is a trivially-simple log format consisting of an ASCII
 table with comments and labelled fields. This package provides a simple Python3
 library to parse such logs.

## vnlog 1.34

=== debian/changelog ===
vnlog (1.34-2) unstable; urgency=medium

  * Cross-building works

 -- Dima Kogan <dkogan@debian.org>  Sat, 14 Jan 2023 14:08:36 -0800

vnlog (1.34-1) unstable; urgency=medium

  * New upstream release
  * vnlog is Multi-Arch: foreign

 -- Dima Kogan <dkogan@debian.org>  Fri, 13 Jan 2023 11:02:49 -0800

vnlog (1.33-2) unstable; urgency=medium

  * libvnlog-perl is Multi-Arch: foreign
  * Cross-building works:
    - Added <!nocheck> profile tags where appropriate
    - Compiler is chosen based on the Debian env vars

 -- Dima Kogan <dkogan@debian.org>  Thu, 12 Jan 2023 13:15:43 -0800

=== debian/control ===
Source: vnlog
Priority: optional
Section: devel
Build-Depends: debhelper-compat (= 11),
 dh-python,
 python3:any,
 libipc-run-perl        <!nocheck>,
 libtext-diff-perl      <!nocheck>,
 liblist-moreutils-perl <!nocheck>,
 python3-numpy          <!nocheck>,
 perl:native            <!nocheck>,
 mawk                   <!nocheck>,
 chrpath
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.1.3
Homepage: https://github.com/dkogan/vnlog/
Vcs-Git: https://salsa.debian.org/science-team/vnlog.git
Vcs-Browser: https://salsa.debian.org/science-team/vnlog
Testsuite: autopkgtest-pkg-python

Package: libvnlog0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog is a trivially-simple log format consisting of an ASCII table with
 comments and labelled fields. This package provides a C library that simplifies
 generating such logs.

Package: libvnlog-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libvnlog0 (= ${binary:Version}), ${perl:Depends},
 libstring-shellquote-perl
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog is a trivially-simple log format consisting of an ASCII table with
 comments and labelled fields. This package provides a C library that simplifies
 generating such logs. Dev files.

Package: vnlog
Section: libdevel
Architecture: all
Depends: ${misc:Depends},
 libvnlog-perl (= ${binary:Version}), ${perl:Depends},
 mawk,
 libtext-table-perl,
 liblist-moreutils-perl,
 moreutils
Suggests: feedgnuplot, ministat, datamash
Multi-Arch: foreign
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog is a trivially-simple log format consisting of an ASCII table with
 comments and labelled fields. This package provides tools to process and
 manipulate such logs. The tools are:
 .
 vnl-filter selects a subset of the rows/columns in a vnlog and/or to
 manipulates the contents. This is effectively an awk wrapper.
 .
 vnl-sort, vnl-uniq, vnl-join, vnl-tail and vnl-ts are wrappers around the
 corresponding commandline tools
 .
 vnl-align aligns vnlog columns for easy interpretation by humans
 .
 vnl-make-matrix converts a one-point-per-line vnlog to a matrix of data

Package: libvnlog-perl
Section: perl
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Multi-Arch: foreign
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog is a trivially-simple log format consisting of an ASCII table with
 comments and labelled fields. This package provides a simple Perl library to
 parse such logs.

Package: python3-vnlog
Section: python
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}, python3-numpy
Provides: ${python3:Provides}
Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
 Vnlog is a trivially-simple log format consisting of an ASCII table with
 comments and labelled fields. This package provides a simple Python3 library to
 parse such logs.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,8 @@
 #!/usr/bin/make -f
+
+# for cross-building
+DPKG_EXPORT_BUILDTOOLS := 1
+include /usr/share/dpkg/buildtools.mk
 
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all

## vnlog 1.36

=== debian/changelog ===
vnlog (1.36-5build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:26:06 +1100

vnlog (1.36-5) unstable; urgency=medium

  * Reverted 64-bit time_t transition. This package is already y2k38
    compliant. See: #1063051

 -- Dima Kogan <dkogan@debian.org>  Wed, 28 Feb 2024 22:33:29 -0800

vnlog (1.36-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063051

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 23:19:22 +0000

vnlog (1.36-4) unstable; urgency=medium

  * More thorough "clean" (Closes: #1047392)

 -- Dima Kogan <dkogan@debian.org>  Mon, 08 Jan 2024 21:22:52 -0800

vnlog (1.36-3) unstable; urgency=medium

  * I only have a single Python parser test now: for python3 (Closes:
    #1042583)

 -- Dima Kogan <dkogan@debian.org>  Sun, 30 Jul 2023 22:36:41 -0700

vnlog (1.36-2) unstable; urgency=medium

  * Source-only re-upload to fix bug (Closes: #1041659)

 -- Dima Kogan <dkogan@debian.org>  Sat, 29 Jul 2023 21:59:59 -0700

vnlog (1.36-1) unstable; urgency=medium

  * New upstream release

    - C API: I don't fflush() with each record

      The standard C library will already do this for line-buffered output
      (for humans) and will NOT do this when writing to files (for
      efficiency). And there's a standard way to force one or the other
      behavior (stdbuf).

 -- Dima Kogan <dkogan@debian.org>  Tue, 25 Jul 2023 23:37:25 -0700

vnlog (1.35-1) unstable; urgency=medium

  * New upstream release
    - Using packaged mrbuild
    - Added vnlog parser in C

 -- Dima Kogan <dkogan@debian.org>  Mon, 19 Jun 2023 12:52:44 -0700

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Priority: optional
 Section: devel
 Build-Depends: debhelper-compat (= 11),
+ mrbuild,
  dh-python,
  python3:any,
  libipc-run-perl        <!nocheck>,
@@ -11,7 +12,8 @@
  perl:native            <!nocheck>,
  mawk                   <!nocheck>,
  chrpath
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Standards-Version: 4.1.3
 Homepage: https://github.com/dkogan/vnlog/
@@ -33,8 +35,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libvnlog0 (= ${binary:Version}), ${perl:Depends},
- libstring-shellquote-perl
+Depends: ${misc:Depends}, libvnlog0 (= ${binary:Version}), ${perl:Depends}
 Description: Toolkit to read/write/manipulate whitespace-separated ASCII logs
  Vnlog is a trivially-simple log format consisting of an ASCII table with
  comments and labelled fields. This package provides a C library that simplifies

## vnlog 1.38

=== debian/changelog ===
vnlog (1.38-1) unstable; urgency=medium

  * New upstream release

    - Python vnlog.slurp() can accept a structured dtype, so it can now
    read non-numerical data

 -- Dima Kogan <dkogan@debian.org>  Tue, 02 Jul 2024 10:19:52 -0700

vnlog (1.37-1) unstable; urgency=medium

  * New upstream release

    - Fixed vnl-filter --perl --stream --eval

 -- Dima Kogan <dkogan@debian.org>  Mon, 27 May 2024 10:27:30 -0700

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,7 @@
  perl:native            <!nocheck>,
  mawk                   <!nocheck>,
  chrpath
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Standards-Version: 4.1.3
 Homepage: https://github.com/dkogan/vnlog/

## vnlog 1.40

=== debian/changelog ===
vnlog (1.40-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Fri, 14 Feb 2025 19:50:28 -0800

vnlog (1.39-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Wed, 29 Jan 2025 09:43:02 -0800

vnlog (1.38-2) unstable; urgency=medium

  * Added Build-Depends: python3-setuptools (Closes: #1080834)

 -- Dima Kogan <dkogan@debian.org>  Thu, 05 Sep 2024 19:16:12 -0700

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,9 @@
 Build-Depends: debhelper-compat (= 11),
  mrbuild,
  dh-python,
+# for "make install" to work. See
+#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080834
+ python3-setuptools,
  python3:any,
  libipc-run-perl        <!nocheck>,
  libtext-diff-perl      <!nocheck>,

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/vnlog-$1\.tar\.gz/ \
  https://github.com/dkogan/vnlog/tags .*/v?(\d\S+)\.tar\.gz

## vnlog 1.41

=== debian/changelog ===
vnlog (1.41-1) unstable; urgency=medium

  * New upstream release
    - Added vnl-tac, vnl-paste

 -- Dima Kogan <dkogan@debian.org>  Thu, 01 Jan 2026 15:10:13 -0800

## vnlog 1.42

=== debian/changelog ===
vnlog (1.42-1) unstable; urgency=medium

  * New upstream release
    - Tests pass if rust-coreutils is used (as it is on ubuntu/resolute)

 -- Dima Kogan <dkogan@debian.org>  Mon, 26 Jan 2026 11:14:30 -0800
